routes/web.php
<?php

Route::get('/', function () {
    return view('welcome');
});

Route::resource('todos', 'TodoController');
Route::get('todos/toggle/{id}', ['as' => 'todos/toggle', 'uses' => 'TodoController@toggle']);

app/Todos.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Todos extends Model
{
    protected $fillable = [
            'externalid',
            'userid',
            'title',
            'completed'
        ];
}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/TodoController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Todos;

class TodoController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $todos = Todos::paginate(10);
        return view('todos.index', compact('todos'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('todos.create');
    }


    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'externalid'=>'integer|unique:todos,externalid|nullable',
            'userid'=>'required',
            'title'=> 'required|string',
            'completed' => 'required|boolean'
        ]);
        $todo = new Todos([
            'externalid'=> $request->get('externalid'),
            'userid' => $request->get('userid'),
            'title'=> $request->get('title'),
            'completed'=> $request->get('completed')
        ]);
        $todo->save();
        return redirect('/todos')->with('success', __('todo.added'));
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $todo = Todos::find($id);

        return view('todos.edit', compact('todo'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'externalid'=> 'integer|unique:todos,externalid,'.$id.'|nullable',
            'userid'=>'required',
            'title'=> 'required|string',
            'completed' => 'required|boolean'
        ]);

        $todo = Todos::find($id);
        $todo->externalid = $request->get('externalid');
        $todo->userid = $request->get('userid');
        $todo->title = $request->get('title');
        $todo->completed = $request->get('completed');
        $todo->save();

        return redirect('/todos')->with('success', __('todo.updated'));
    }

    /**
     * Toogle
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function toggle($id)
    {
        $todo = Todos::find($id);
        $todo->completed = !$todo->completed;
        $todo->save();

        return redirect('/todos')->with(
            'success',
            __('todo.toggled')
        );
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $todo = Todos::find($id);
        $todo->delete();

        return redirect('/todos')->with('success', __('todo.deleted'));
    }
}

resources/views/layout.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>TODO List</title>
    <link href="{{ asset('css/app.css') }}" rel="stylesheet" type="text/css" />
</head>
<body>
<div class="container">
    @yield('content')
</div>
<script src="{{ asset('js/app.js') }}" type="text/js"></script>
</body>
</html>

resources/views/todos/create.blade.php
@extends('layout')

@section('content')
    <style>
        .uper {
            margin-top: 40px;
        }
    </style>
    <div class="card uper">
        <div class="card-header">
            @lang('todo.add')
        </div>
        <div class="card-body">
            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div><br />
            @endif
            <form method="post" action="{{ route('todos.store') }}">
                <div class="form-group">
                    @csrf
                    <label for="externalid">@lang('todo.externalid')</label>
                    <input type="text" class="form-control" name="externalid"/>
                </div>
                <div class="form-group">
                    <label for="userid">@lang('todo.userid')</label>
                    <input type="text" class="form-control" name="userid"/>
                </div>
                <div class="form-group">
                    <label for="title">@lang('todo.title')</label>
                    <input type="text" class="form-control" name="title"/>
                </div>
                <div class="form-group">
                    <label for="completed">@lang('todo.completed')</label>
                    <select class="form-control" name="completed">
                        <option value="0">@lang('todo.no')</option>
                        <option value="1">@lang('todo.yes')</option>
                    </select>
                </div>
                <button type="submit" class="btn btn-primary">@lang('todo.btn_add')</button>
            </form>
        </div>
    </div>
@endsection

resources/views/todos/edit.blade.php
@extends('layout')

@section('content')
    <style>
        .uper {
            margin-top: 40px;
        }
    </style>
    <div class="card uper">
        <div class="card-header">
            @lang('todo.edit')
        </div>
        <div class="card-body">
            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div><br />
            @endif
            <form method="post" action="{{ route('todos.update', $todo->id) }}">
                @method('PATCH')
                @csrf
                <div class="form-group">
                    <label for="externalid">@lang('todo.externalid')</label>
                    <input type="text" class="form-control" name="externalid" value="{{ $todo->externalid }}" />
                </div>
                <div class="form-group">
                    <label for="userid">@lang('todo.userid')</label>
                    <input type="text" class="form-control" name="userid" value={{ $todo->userid }} />
                </div>
                <div class="form-group">
                    <label for="title">@lang('todo.title')</label>
                    <input type="text" class="form-control" name="title" value="{{ $todo->title }}" />
                </div>
                <div class="form-group">
                    <label for="completed">@lang('todo.completed')</label>
                    <select class="form-control" name="completed" value={{ $todo->completed }}>
                        <option value="0">No</option>
                        <option value="1" @if ($todo->completed)selected @endif>Yes</option>
                    </select>
                </div>
                <button type="submit" class="btn btn-primary">@lang('todo.btn_update')</button>
            </form>
        </div>
    </div>
@endsection

resources/views/todos/index.blade.php
@extends('layout')

@section('content')
    <style>
        .uper {
            margin-top: 40px;
        }
    </style>
    <div class="uper">
        @if(session()->get('success'))
            <div class="alert alert-success">
                {{ session()->get('success') }}
            </div><br />
        @endif
        <div>
            <a href="{{ route('todos.create')}}" class="btn btn-primary">@lang('todo.btn_add')</a>
        </div>
        <table class="table table-striped">
            <thead>
            <tr>
                <td>@lang('todo.id')</td>
                <td>@lang('todo.externalid')</td>
                <td>@lang('todo.userid')</td>
                <td>@lang('todo.title')</td>
                <td>@lang('todo.completed')</td>
                <td colspan="3">@lang('todo.action')</td>
            </tr>
            </thead>
            <tbody>
            @foreach($todos as $todo)
                <tr>
                    <td>{{$todo->id}}</td>
                    <td>{{$todo->externalid}}</td>
                    <td>{{$todo->userid}}</td>
                    <td>{{$todo->title}}</td>
                    <td>{{$todo->completed}}</td>
                    <td><a href="{{ route('todos/toggle',$todo->id)}}" class="btn btn-primary">Toogle</a></td>
                    <td><a href="{{ route('todos.edit',$todo->id)}}" class="btn btn-primary">Edit</a></td>
                    <td>
                        <form action="{{ route('todos.destroy', $todo->id)}}" method="post">
                            @csrf
                            @method('DELETE')
                            <button class="btn btn-danger" type="submit">Delete</button>
                        </form>
                    </td>
                </tr>
            @endforeach
            </tbody>
        </table>
            {{ $todos->links() }}
        <div>
@endsection